//Downloaded from
//Visual C# Kicks - http://vckicks.110mb.com/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
//Needed
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace ServerTime
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnTime_Click(object sender, EventArgs e)
        {
            MessageBox.Show(ServerTime.getServerTime().ToLocalTime().ToString());
        }
    }

    internal class ServerTime
    {
        //List of servers that give the exact time
        private static string[] servers = { "129.6.15.28", "129.6.15.29", "132.163.4.101", "132.163.4.102", "132.163.4.103", "128.138.140.44", "192.43.244.18", "131.107.1.10", "66.243.43.21", "216.200.93.8", "208.184.49.9", "207.126.98.204", "205.188.185.33" };
        
        public static DateTime getServerTime()
        {
            foreach (string server in servers)
            {
                DateTime result = connectServer(server);
                if (result > DateTime.MinValue)
                    return result; //Time acquired
            }

            //No time was found
            return DateTime.MinValue;
        }

        private static DateTime connectServer(string host)
        {
            string time;
            try
            {
                StreamReader read = new StreamReader(new TcpClient(host, 13).GetStream());
                DateTime systemTime = DateTime.UtcNow;
                time = read.ReadToEnd();
            }
            catch (Exception)
            {
                //Couldn't connect to the server
                return DateTime.MinValue;
            }

            //If this point is reached then we can assume we have a time string

            //Check for the signature
            if (time.Substring(38, 9) != "UTC(NIST)") return DateTime.MinValue;

            //Check to see if the server reports the time is off
            if (time.Substring(30, 1) != "0") return DateTime.MinValue;

            //Extract the values
            int jd = int.Parse(time.Substring(1, 5));
            int yr = int.Parse(time.Substring(7, 2));
            int mo = int.Parse(time.Substring(10, 2));
            int dy = int.Parse(time.Substring(13, 2));
            int hr = int.Parse(time.Substring(16, 2));
            int mm = int.Parse(time.Substring(19, 2));
            int sc = int.Parse(time.Substring(22, 2));

            //Make sure time makes sense
            if (jd < 15020) return DateTime.MinValue; //Year is before 1900

            if (jd > 51544)
                yr += 2000;
            else
                yr += 1900;

            return new DateTime(yr, mo, dy, hr, mm, sc);
        }
    }
}